using System;
using System.Collections.Generic;
using jp.netgamers.free.tuogl;	//	OpenGL ̔bp[ڎwĂ
using jp.netgamers.free.tugame;	//	OpenGL ̃CuڎwĂ

class MyPrimitive
{
	public short[]	va;
	public uint[]	ca;

	public MyPrimitive( String path )
	{
		va = TUAssets.readTSVArray<short>( path + "/vertex.tsv" );
		ca = TUAssets.readTSVArray<uint>( path + "/color.tsv" );
	}

	public void draw( float x, float y, float z, float a )
	{
		GL1.VertexPointer( 3, va );	//	_W̐ݒ
		GL1.ColorPointer(			//	F̐ݒ
		 4,							//	F̗vf
		 GL1._UNSIGNED_BYTE,		//	f[^̌^
		 0,							//	f[^Ԋu
		 ca );						//	Ff[^

		GL1.PushMatrix();			//	}gbNXX^bNɊi[
		GL1.Translatef( x, y, z );	//	sړ
		GL1.Rotatef( a, 0, 0, 1 );	//	Zŉ]
		GL1.DrawArrays(				//	z`
		 GL1._TRIANGLES,			//	Op`̕`
		 0,							//	Jnʒu
		 va.Length / 3 );			//	_
		GL1.PopMatrix();			//	}gbNXX^bNo
	}

	public void draw( float x, float y, float z, float a, float s )
	{
		GL1.VertexPointer( 3, va );	//	_W̐ݒ
		GL1.ColorPointer(			//	F̐ݒ
		 4,							//	F̗vf
		 GL1._UNSIGNED_BYTE,		//	f[^̌^
		 0,							//	f[^Ԋu
		 ca );						//	Ff[^

		GL1.PushMatrix();			//	}gbNXX^bNɊi[
		GL1.Translatef( x, y, z );	//	sړ
		GL1.Rotatef( a, 0, 0, 1 );	//	Zŉ]
		GL1.Scale( s );				//	傫ύX
		GL1.DrawArrays(				//	z`
		 GL1._TRIANGLES,			//	Op`̕`
		 0,							//	Jnʒu
		 va.Length / 3 );			//	_
		GL1.PopMatrix();			//	}gbNXX^bNo
	}

	public void draw( float x, float y, float z, float a, float s, float v, float w )
	{
		GL1.VertexPointer( 3, va );	//	_W̐ݒ
		GL1.ColorPointer(			//	F̐ݒ
		 4,							//	F̗vf
		 GL1._UNSIGNED_BYTE,		//	f[^̌^
		 0,							//	f[^Ԋu
		 ca );						//	Ff[^

		GL1.PushMatrix();			//	}gbNXX^bNɊi[
		GL1.Translatef( x, y, z );	//	sړ
		GL1.Rotatef( a, 0, 0, 1 );	//	Zŉ]
		GL1.Scalef( s, 1, 1 );		//	傫ύX
		GL1.Translatef( v, w, 0 );	//	sړ
		GL1.DrawArrays(				//	z`
		 GL1._TRIANGLES,			//	Op`̕`
		 0,							//	Jnʒu
		 va.Length / 3 );			//	_
		GL1.PopMatrix();			//	}gbNXX^bNo
	}

}

class MyModel
{
	public static String[]	Name = { "Akichi", "Building","Hatake","House","Azemichi","Jisya","Platform","Ekisya", "Rail","Train", "House3", "House2", "House1", "House5", "Cursor", "Sea" };
	public static Dictionary<String, MyPrimitive>	Pri = new Dictionary<String, MyPrimitive>();

	public static void load()
	{
		foreach( String s in Name ){
			Pri[ s ] = new MyPrimitive( s );
		}
	}

	public static void drawRail( int x, int y, int a )
	{
		if( a % 4 == 0 ){	//	90xP
			Pri[ "Rail" ].draw( x, y, 0, a * 22.5f, 1, 0, -11 );
			Pri[ "Rail" ].draw( x, y, 0, a * 22.5f, 1, 0,  11 );
			return;
		}

		if( a % 2 == 0 ){	//	45xP
			Pri[ "Rail" ].draw( x, y, 0, a * 22.5f, 1.42f, 0, -11 );
			Pri[ "Rail" ].draw( x, y, 0, a * 22.5f, 1.42f, 0,  11 );
			return;
		}

		if( a % 4 == 1 ){	//	22.5 + 90n xP
			Pri[ "Rail" ].draw( x, y, 0, a * 22.5f + 3.9f, 1.25f,  8, 12 );
			Pri[ "Rail" ].draw( x, y, 0, a * 22.5f + 4.0f, 1.1f , 11, 33 );
			return;
		}

		Pri[ "Rail" ].draw( x, y, 0, a * 22.5f - 3.9f, 1.25f,  -8, 12 );
		Pri[ "Rail" ].draw( x, y, 0, a * 22.5f - 4.0f, 1.1f , -11, 33 );
	}

	public static void drawRail( int[] xyta )
	{
		if( xyta == null ){
			return;
		}

		for( int i = 0; i < xyta.Length; i += 4 ){
			drawRail( xyta[ i + 0 ] * 100,
			          xyta[ i + 1 ] * 100,
			          xyta[ i + 3 ] );
		}
	}
}

class MyMap
{
	public static readonly sbyte AKICHI		= 0;
	public static readonly sbyte BUILDING	= 1;
	public static readonly sbyte HATAKE		= 2;
	public static readonly sbyte HOUSE		= 3;
	public static readonly sbyte AZEMICHI	= 4;
	public static readonly sbyte JISYA		= 5;
	public static readonly sbyte PLATFORM	= 6;
	public static readonly sbyte EKISYA		= 7;
	public static readonly sbyte RAIL		= 8;
	public static readonly sbyte TRAIN		= 9;
	public static readonly sbyte HOUSE3		= 10;
	public static readonly sbyte HOUSE2		= 11;
	public static readonly sbyte HOUSE1		= 12;
	public static readonly sbyte HOUSE5		= 13;
	public static readonly sbyte POINT		= 14;	//	

	public static int		Width, Height;
	public static sbyte[]	Data;
	public static sbyte[]	Angle;

	public static int[] createRail( int sx, int sy, int ex, int ey )
	{
		int		dx = ex - sx;
		int		dy = ey - sy;
		int		lx = Math.Abs( dx );
		int		ly = Math.Abs( dy );
		int		len;
		if( lx < ly ){
			len = ly;
		}else{
			len = lx;
		}

		int[]	r = new int[ ( len + 2 ) * 4 ];
		r[ len * 4 + 4 ] = -1;
		int		a = TULib.getAngle16i( dx, dy );
		int		t = getType( sx, sy );

		if( t == RAIL ){
			if( !isRail( sx + getNextRailX( a ), sy + getNextRailY( a ) ) ){
				a = getAngle( sx, sy );
			}
		}

		r[ 0 ] = sx;
		r[ 1 ] = sy;
		r[ 2 ] = RAIL;
		r[ 3 ] = a;

		if( t == PLATFORM ){
			a = r[ 3 ] = getAngle( sx, sy );
			r[ 2 ] = PLATFORM;
		}

		sx *= 2;
		sy *= 2;
		dx *= 2;
		dy *= 2;
		sx++;
		sy++;
		sx += Math.Sign( getRailDX( a ) );
		sy += Math.Sign( getRailDY( a ) );
		dx -= Math.Sign( getRailDX( a ) );
		dy -= Math.Sign( getRailDY( a ) );

		if( ( a & 3 ) == 3 ){
			r[ 3 ] ^= 8;
		}

		for( int i = 1; i <= len; i++ ){
			a = TULib.getAngle16i( dx, dy );
			int		b = (int)TULib.getAngle360( dx, dy ) % 180;
			int		c = a & 7;

			if( ( sx & 1 ) == 0 && c == 4 ){
				a += b > 90 ? 1 : -1;
			}

			if( ( sy & 1 ) == 0 && c == 0 ){
				a += b < 90 ? 1 : -1;
			}

			if( ( sx & 1 ) == 1 ){
				if( c < 3 ){
					a += 3 - c;
				}
				if( c > 5 ){
					a -= c - 5;
				}
			}
			if( ( sy & 1 ) == 1 ){
				if( c == 2 || c == 3 ){
					a -= c - 1;
				}if( c == 5 || c == 6 ){
					a += 7 - c;
				}
			}
			a &= 15;

			int		ax = getRailDX( a );
			int		ay = getRailDY( a );

			c = a & 7;
			if( ( c == 1 && ( sy & 1 ) == 0 ) ||
			    ( c == 3 && ( sx & 1 ) == 1 ) ||
			    ( c == 5 && ( sx & 1 ) == 0 ) ||
			    ( c == 7 && ( sy & 1 ) == 1 ) ){
				a ^= 8;
			}

			r[ i * 4 + 0 ] = (int)( ( sx + ax / 2.0f ) / 2 );
			r[ i * 4 + 1 ] = (int)( ( sy + ay / 2.0f ) / 2 );
			r[ i * 4 + 2 ] = RAIL;
			r[ i * 4 + 3 ] = a;

			t = getType( r[ i * 4 ], r[ i * 4 + 1 ] );
			if( t == PLATFORM || t == EKISYA || t == POINT ){
				r[ i * 4 + 4 ] = -2;
				r[ len * 4 + 4 ] = -2;
				return( r );
			}
			if( t == RAIL ){
				r[ i * 4 + 4 ] = -2;
				if( Math.Abs( diffAngle8( a, getAngle( r[ i * 4 ], r[ i * 4 + 1 ] ) ) ) > 1 ){
					r[ len * 4 + 4 ] = -2;
				}
				return( r );
			}

			sx += ax;
			sy += ay;
			dx -= ax;
			dy -= ay;
		}

		return( r );
	}

	public static int diffAngle8( int a )
	{
		if( a >= 4 )	a -= 8;
		if( a < -4 )	a += 8;
		return( a );
	}

	public static int diffAngle8( int a, int b )
	{
		return( diffAngle8( diffAngle16( a, b ) ) );
	}

	public static int diffAngle16( int a, int b )
	{
		int		r = b - a;
		if( r >= 8 )	r -= 16;
		if( r < -8 )	r += 16;
		return( r );
	}

	public static void draw( int cx, int cy, int size )
	{
		for( int my = cy - size; my <= cy + size; my++ ){
			for( int mx = cx - size; mx <= cx + size; mx++ ){
				int		x = mx * 100;
				int		y = my * 100;
				if( !isRegion( mx, my ) ){
					MyModel.Pri[ "Sea" ].draw( x, y, 0, 0 );
					continue;
				}
				int		a = getAngle( mx, my );
				int		t = getType( mx, my );
				if( t < 0 ){
					continue;
				}
				if( t == RAIL ){
					MyModel.Pri[ "Jisya" ].draw( x, y, 0, 0 );
					MyModel.drawRail( x, y, a );	//	[`
					continue;
				}
				if( t == POINT ){
					MyModel.Pri[ "Jisya" ].draw( x, y, 0, 0 );
					MyModel.drawRail( x, y, a );		//	[`
					MyModel.drawRail( x, y, a + 1 );	//	[`
					continue;
				}
				if( t == PLATFORM ){
					MyModel.Pri[ "Platform" ].draw( x, y, 0, a * 22.5f );
					MyModel.drawRail( x, y, a );	//	[`
					continue;
				}
				if( isTwice( t ) ){
					MyModel.Pri[ MyModel.Name[ t ] ].draw( x + 50, y + 50, 0, a * 22.5f, 2 );
					continue;
				}
				MyModel.Pri[ MyModel.Name[ t ] ].draw( x, y, 0, a * 22.5f );
			}
		}
	}

	public static int getNextRailX( int a )
	{
		if( a >= 5 && a <= 10 )	return( -1 );
		if( a >= 3 && a <= 12 )	return(  0 );
		return( 1 );
	}

	public static int getNextRailY( int a )
	{
		if( a >= 1 && a <=  6 )	return(  1 );
		if( a >= 9 && a <= 14 )	return( -1 );
		return( 0 );
	}

	public static int getRailDX( int a )
	{
		if( a <= 2 || a >= 14 )	return(  2 );
		if( a == 3 || a == 13 )	return(  1 );
		if( a == 4 || a == 12 )	return(  0 );
		if( a == 5 || a == 11 )	return( -1 );
		return( -2 );
	}

	public static int getRailDY( int a )
	{
		if( a == 9 || a == 15 )	return( -1 );
		if( a == 0 || a ==  8 )	return(  0 );
		if( a == 1 || a ==  7 )	return(  1 );
		if( a <= 6            )	return(  2 );
		return( -2 );
	}

	public static int getAngle( int mx, int my )
	{
		return( Angle[ my * Width + mx ] );
	}

	public static int getPointAngle( int a, int b )
	{
		if( Math.Abs( diffAngle16( a, b ) ) != 1 ){
			if( ( a & 1 ) == 0 ){
				a ^= 8;
			}else{
				b ^= 8;
			}
		}

		return( diffAngle16( a, b ) == 1 ? a : b );
	}

	public static int getType( int mx, int my )
	{
		return( Data[ my * Width + mx ] );
	}

	public static void init( int width, int height )
	{
		Width = width;
		Height = height;

		Data = new sbyte[ Width * Height ];
		Angle = new sbyte[ Width * Height ];

		for( int i = 0; i < 10000; i++ ){
			MyMap.set( TUGame.rnd( Width ), TUGame.rnd( Height ), BUILDING, 0 );
		}

		for( int i = 0; i < 1000000; i++ ){
			MyMap.set( TUGame.rnd( Width ), TUGame.rnd( Height ), HATAKE, 0 );
		}

		for( int i = 0; i < 100000; i++ ){
			MyMap.set( TUGame.rnd( Width ), TUGame.rnd( Height ), HOUSE5, 0 );
		}

		for( int i = 0; i < 100000; i++ ){
			MyMap.set( TUGame.rnd( Width ), TUGame.rnd( Height ), HOUSE, 0 );
		}

		for( int i = 0; i < 100000; i++ ){
			MyMap.set( TUGame.rnd( Width ), TUGame.rnd( Height ), HOUSE3, 0 );
		}

		for( int i = 0; i < 100000; i++ ){
			MyMap.set( TUGame.rnd( Width ), TUGame.rnd( Height ), HOUSE2, 0 );
		}

		for( int i = 0; i < 100000; i++ ){
			MyMap.set( TUGame.rnd( Width ), TUGame.rnd( Height ), HOUSE1, 0 );
		}

		for( int y = 0; y < Height; y++ ){
			MyMap.set( 16, y, AZEMICHI, 4 );
		}

		for( int x = 0; x < Width; x++ ){
			MyMap.set( x, 16, RAIL, 0 );
		}

		for( int x = 4; x < 29; x++ ){
			MyMap.set( x, 16, PLATFORM, 0 );
			MyMap.set( x, 17, PLATFORM, 8 );
		}

		MyMap.set( 16, 15, EKISYA, 0 );
	}

	public static void del( int mx, int my )
	{
		int		t = getType( mx, my );
		if( t == -1 ){
			del( mx - 1, my );
			return;
		}
		if( t == -2 ){
			del( mx, my - 1 );
			return;
		}
		if( !isTwice( t ) ){
			return;
		}

		setType( mx    , my    , HATAKE );
		setType( mx + 1, my    , HATAKE );
		setType( mx    , my + 1, HATAKE );
		setType( mx + 1, my + 1, HATAKE );
	}

	public static bool isRail( int mx, int my )
	{
		int		t = getType( mx, my );
		return( t == RAIL || t == POINT || t == PLATFORM );
	}

	public static bool isRegion( int mx, int my )
	{
		return( mx >= 0 && mx < Width &&
		        my >= 0 && my < Height );
	}

	public static bool isTwice( int t )
	{
		return( t == HOUSE  ||
		        t == HOUSE1 ||
		        t == HOUSE2 ||
		        t == HOUSE3 ||
		        t == HOUSE5 ||
		        t == BUILDING );
	}

	public static bool set( int mx, int my, sbyte t, sbyte a )
	{
		if( !isRegion( mx, my ) ){
			return( false );
		}
		del( mx, my );
		setType( mx, my, t );
		MyMap.Angle[ my * Width + mx ] = a;
		if( isTwice( t ) ){
			set( mx + 1, my    , -1, 0 );
			set( mx    , my + 1, -2, 0 );
			set( mx + 1, my + 1, -2, 0 );
		}
		return( true );
	}

	public static int set( int[] xyta )
	{
		for( int i = 0; i < xyta.Length; i += 4 ){
			if( !set( xyta[ i ], xyta[ i + 1 ], (sbyte)xyta[ i + 2 ], (sbyte)xyta[ i + 3 ] ) ){
				return( i / 4 );
			}
		}
		return( xyta.Length / 4 );
	}

	public static int setRail( int[] xyta )
	{
		for( int i = 0; i < xyta.Length; i += 4 ){
			if( !isRegion( xyta[ i ], xyta[ i + 1 ] ) ){
				break;
			}
			if( getType( xyta[ i ], xyta[ i + 1 ] ) != RAIL ){
				continue;
			}

			int		a = getAngle( xyta[ i ], xyta[ i + 1 ] );
			if( Math.Abs( diffAngle8( a, xyta[ i + 3 ] ) ) != 1 ){
				continue;
			}
			xyta[ i + 2 ] = POINT;
			xyta[ i + 3 ] = getPointAngle( a, xyta[ i + 3 ] );
		}

		return( set( xyta ) );
	}

	public static bool setType( int mx, int my, sbyte t )
	{
		if( !isRegion( mx, my ) ){
			return( false );
		}
		Data[ my * Width + mx ] = t;
		return( true );
	}
}

class ETrain : TURetroGame, ITUChoose
{
	static float		PX = 1600;		//	vC[̍W
	static float		CenterX = 1600, CenterY = 1600;	//	ʒW
	static int			Count;			//	_
	static float		Mag = 1.0f;		//	{
	static float		WorldX, WorldY;	//	[hW
	static bool			MoveCenter;		//	Wړw
	static bool			MoveMouse;		//	}EXړtO
	static int			StartX = -1, StartY;	//	n_
	static int			EndX, EndY;		//	I_
	static int[]		Plan;			//	v
	static bool			Perspective = false;	//	e
	static int			Speed;			//	Q[isx
	static bool			Stop;			//	Q[is~tO
	static bool			bRotate;		//	]tO
	static sbyte		Angle = -96;	//	_̊px
	static int			Command;		//	sR}h
	static TU2DButton	Btn1 = new TU2DButton( -58, -31, 11, 9, "~", "STOP"    );	//	{^
	static TU2DButton	Btn2 = new TU2DButton( -46, -31, 11, 9, "ᑬ", "SPD. DN" );	//	{^
	static TU2DButton	Btn3 = new TU2DButton( -34, -31, 11, 9, "", "SPD. UP" );	//	{^
	static TU2DButton	Btn4 = new TU2DButton( -22, -31, 11, 9, "ڍ", "REDUCT."  );	//	{^
	static TU2DButton	Btn5 = new TU2DButton( -10, -31, 11, 9, "L", "EXPANS."  );	//	{^
	static TU2DButton	Btn6 = new TU2DButton(   2, -31, 11, 9, "ؑ", "SWITCH"  );	//	{^
	static TU2DButton	Btn7 = new TU2DButton(  14, -31, 11, 9, "", "ROTAT.L" );	//	{^
	static TU2DButton	Btn8 = new TU2DButton(  26, -31, 11, 9, "E", "ROTAT.R" );	//	{^
	static TU2DButton	Btn10 = new TU2DButton( -50, 20, 20, 9, "H~", "LINE LAYING" );	//	{^
	static TU2DButton	Btn11 = new TU2DButton( -50, 10, 20, 9, "HP", "LINE REMOVAL" );	//	{^
	static TUDate		DT = new TUDate( 60, 1970, 1, 1, 9, 0, 0 );	//	1/60bPʁB1970/1/1 9:00:00

	public override void wmCreated()
	{
		Title = "Edɏ낤";
		MyMap.init( 2048, 2048 );
		MyModel.load();
		Btn1.Choose = this;
		Btn2.Choose = this;
		Btn3.Choose = this;
		Btn4.Choose = this;
		Btn5.Choose = this;
		Btn6.Choose = this;
		Btn7.Choose = this;
		Btn8.Choose = this;
		Btn10.Choose = this;
		Btn11.Choose = this;
		DT.setFormat( "yyyy/MM/dd HH:mm:ss.ff" );	//	̏ݒ
		setFrameRate( 60 );
	}

	public override void wmMouseClickL( float x, float y )
	{
		if( MoveMouse ){
			MoveMouse = false;
			return;
		}

		if( Command == 0 ){
			return;
		}

		if( StartX < 0 ){
			StartX = EndX = getCursorX();
			StartY = EndY = getCursorY();
			return;
		}

		if( Command == 1 ){
			if( Plan == null ){
				return;
			}

			if( Plan[ Plan.Length - 4 ] < -1 ){
				return;
			}

			int		i = MyMap.setRail( Plan );
			EndX = Plan[ i * 4 - 4 ];
			EndY = Plan[ i * 4 - 3 ];
		}else{
			for( int my = StartY; my != EndY; my += Math.Sign( EndY - StartY ) ){
				for( int mx = StartX; mx != EndX; mx += Math.Sign( EndX - StartX ) ){
					if( MyMap.getType( mx, my ) == MyMap.RAIL ){
						MyMap.set( mx, my, MyMap.JISYA, 0 );
					}
				}
			}
		}

		CenterX += ( EndX - StartX ) * 100;
		CenterY += ( EndY - StartY ) * 100;
		StartX = EndX;
		StartY = EndY;
	}

	public override void onMouseClickR( int x, int y )
	{
		if( StartX >= 0 ){
			StartX = -1;
			Plan = null;
			return;
		}

		Command = 0;
	}

	public override void onMouseWheel( int d )
	{
		Mag += d / 4.0f;
		if( Mag < 0.5f )	Mag = 0.5f;
		if( Mag > 2.0f )	Mag = 2.0f;
		MoveCenter = true;		//	Wړw
	}

	public override void wmTimer()
	{
		if( Btn7.isDown() ){
			Angle++;
			bRotate = true;
		}
		if( Btn8.isDown() ){
			Angle--;
			bRotate = true;
		}

		//	f̃n{eôh߁Apx𐧌
		if( Angle < -96 )	Angle = -96;
		if( Angle > -64 )	Angle = -64;

		if( Stop ){
			return;
		}

		for( int i = (int)Math.Pow( 2, Speed ); i > 0; i-- ){
			elapse();
		}

		Invalidate();	//	ĕ`˗
	}

	public override void wmDraw()
	{
		GL1.Clear(					//	ʃNA
		 GL1._DEPTH_BUFFER_BIT |	//	[xobt@
		 GL1._COLOR_BUFFER_BIT );	//	Fobt@

		GL1.MatrixMode( GL1._PROJECTION );	//	ˉeϊ̐ݒ胂[hɐ؂ւ
		GL1.PushMatrix();			//	}gbNXX^bNɊi[
		GL1.LoadIdentity();			//	ftHg̃}gbNXǂݍ

		float	m = 0.0453f * Mag;
		if( Perspective ){
			//	eɐݒ
			GL1.Frustum( getWidthf(), getHeightf(), 270, 14000 );
		}else{
			//	seɐݒ
			GL1.Ortho( getWidthf() / m, getHeightf() / m, 0, 13000 );
		}

		GL1.MatrixMode( GL1._MODELVIEW );	//	fr[ϊ̐ݒ胂[hɐ؂ւ

		GL1.LoadIdentity();			//	ftHg̃}gbNXǂݍ
		GL1.LookAt(					//	_ݒ
		(float)Math.Cos( Angle * Math.PI / 0x80 ) * 200 / m,					//	J̈ʒuX
		(float)Math.Sin( Angle * Math.PI / 0x80 ) * 200 / m,					//	J̈ʒuY
		115.6f / m,					//	J̈ʒuZ
		   0,   0,  0,				//	Jʂ̒
		   0,   0,  1 );			//	J̌

		GL1.Enable( GL1._DEPTH_TEST );	//	[xeXgL
		GL1.EnableClientState( GL1._COLOR_ARRAY );	//	FzL
//		GL1.Scale( 0.0453f * Mag );	//	XP[ύXBglScalef( 0.0453f, 0.0453f, 0.0453f );

		GL1.Translatef( -CenterX, -CenterY, 0 );	//	sړ

//		float[]	xyz = GL1.UnProject( MouseX, getHeight() - MouseY - 1 );
//		float[]	xyz = UnProjectMouse();	//	}EXW gluUnProject Ăяo
		UnProjectMouse( 0 );	//	}EXʒu ZW 0 ̃[hW擾Bʂ̓oϐ MouseW Ɋi[B
		if( ( MouseL | MoveCenter ) && !bRotate ){		//	}EX{^A͒Wړw̏ꍇ
			float	dx = WorldX - MouseW[ 0 ];
			float	dy = WorldY - MouseW[ 1 ];
			if( dx != 0.0f || dy != 0.0f ){
				if( !MoveCenter ){
					MoveMouse = true;
				}
				CenterX += dx;
				CenterY += dy;
				GL1.Translatef( -dx, -dy, 0 );	//	sړ
			}
			MoveCenter = false;
		}else{
			bRotate = false;
			WorldX = MouseW[ 0 ];	//	}EXʒu ZW 0 ̃[hWXێĂB
			WorldY = MouseW[ 1 ];	//	}EXʒu ZW 0 ̃[hWYێĂB
		}

		MyMap.draw( (int)( CenterX / 100 ), (int)( CenterY / 100 ), (int)( 24 / Mag ) );			//	`

		//	Ԃ`
		for( int i = 0; i < 12; i++ ){
			MyModel.Pri[ "Train" ].draw( PX - i * 200, 1600, 4, 0 );
		}

		//	J[\`
		if( Command != 0 ){
			MyModel.Pri[ "Cursor" ].draw( getCursorX() * 100, getCursorY() * 100, 0, 0 );
		}

		GL1.DisableClientState( GL1._COLOR_ARRAY );	//	Fz𖳌
		GL1.Disable( GL1._DEPTH_TEST );

		//	v`
		if( StartX >= 0 ){
			if( Command == 1 ){
				if( EndX != getCursorX() || EndY != getCursorY() ){
					EndX = getCursorX();
					EndY = getCursorY();
					Plan = MyMap.createRail( StartX, StartY, EndX, EndY );
				}
				if( Plan != null ){
					if( Plan[ Plan.Length - 4 ] < -1 ){
						GL1.Color4( 0xffff0000 );
					}else{
						GL1.Color4( 0xffffff00 );
					}
					MyModel.drawRail( Plan );
				}
			}else{
				EndX = getCursorX();
				EndY = getCursorY();
				for( int my = StartY; my != EndY; my += Math.Sign( EndY - StartY ) ){
					for( int mx = StartX; mx != EndX; mx += Math.Sign( EndX - StartX ) ){
						if( MyMap.getType( mx, my ) == MyMap.RAIL ){
							GL1.Color4ABGR( 0x550000ff );
						}else{
							GL1.Color4ABGR( 0x2200ffff );
						}
						MyModel.Pri[ "Cursor" ].draw( mx * 100, my * 100, 0, 0 );
					}
				}
			}
		}

		GL1.MatrixMode( GL1._PROJECTION );	//	ˉeϊ̐ݒ胂[hɐ؂ւ
		GL1.PopMatrix();			//	}gbNXX^bNo
		GL1.MatrixMode( GL1._MODELVIEW );	//	fr[ϊ̐ݒ胂[hɐ؂ւ
		GL1.LoadIdentity();				//	ftHg̃}gbNXǂݍ

		DT.set( Count );	//	oߎԂݒ
		draw( DT.toString(), -63, 35 );

		Btn1.draw();
		Btn2.draw();
		Btn3.draw();
		Btn4.draw();
		Btn5.draw();
		Btn6.draw();
		Btn7.draw();
		Btn8.draw();
		Btn10.draw();
		Btn11.draw();
	}

	public bool choose( Object obj )
	{
		if( obj == Btn1 ){	//	~
			Stop ^= true;
		}
		if( obj == Btn2 ){	//	ᑬ
			Speed--;
		}
		if( obj == Btn3 ){	//	
			Speed++;
		}
		if( obj == Btn4 ){	//	ڍ
			onMouseWheel( 1 );
		}
		if( obj == Btn5 ){	//	L
			onMouseWheel( -1 );
		}
		if( obj == Btn6 ){	//	ؑ
			Perspective ^= true;
		}

		if( obj == Btn10 ){	//	H~
			Command = 1;
		}
		if( obj == Btn11 ){	//	HP
			Command = 2;
		}

		return( true );
	}

	static void elapse()
	{
		Count++;
		PX += 2;
	}

	static int getCursorX()
	{
		return( ( (int)WorldX + 50 ) / 100 );
	}

	static int getCursorY()
	{
		return( ( (int)WorldY + 50 ) / 100 );
	}

	static void Main()
	{
		new ETrain();
	}
}
